From 133d9d5d9d8910d1071470d0cd1ac187a0ee9671 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 02 2020 04:36:12 +0000
Subject: [PATCH 85/2232] Merge pull request #56 from dtolnay/cast


Change cast operators to explicit
---

diff --git a/demo-cxx/demo.cc b/demo-cxx/demo.cc
index b975e88..04287b8 100644
--- a/demo-cxx/demo.cc
+++ b/demo-cxx/demo.cc
@@ -10,7 +10,7 @@ ThingC::ThingC(std::string appname) : appname(std::move(appname)) {}
 ThingC::~ThingC() { std::cout << "done with ThingC" << std::endl; }
 
 std::unique_ptr<ThingC> make_demo(rust::Str appname) {
-  return std::unique_ptr<ThingC>(new ThingC(appname));
+  return std::unique_ptr<ThingC>(new ThingC(std::string(appname)));
 }
 
 const std::string &get_name(const ThingC &thing) { return thing.appname; }
diff --git a/gen/write.rs b/gen/write.rs
index 381800b..e0396c9 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -191,8 +191,10 @@ fn write_cxx_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
         write!(out, "(");
     } else if let Some(ret) = &efn.ret {
         write!(out, "return ");
-        if let Type::Ref(_) = ret {
-            write!(out, "&");
+        match ret {
+            Type::Ref(_) => write!(out, "&"),
+            Type::Str(_) => write!(out, "::rust::Str::Repr("),
+            _ => {}
         }
     }
     write!(out, "{}$(", efn.ident);
@@ -216,6 +218,7 @@ fn write_cxx_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
     match &efn.ret {
         Some(Type::RustBox(_)) => write!(out, ".into_raw()"),
         Some(Type::UniquePtr(_)) => write!(out, ".release()"),
+        Some(Type::Str(_)) => write!(out, ")"),
         _ => {}
     }
     if indirect_return {
@@ -293,13 +296,16 @@ fn write_rust_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
             if i > 0 {
                 write!(out, ", ");
             }
-            if types.needs_indirect_abi(&arg.ty) {
-                write!(out, "&");
+            match &arg.ty {
+                Type::Str(_) => write!(out, "::rust::Str::Repr("),
+                ty if types.needs_indirect_abi(ty) => write!(out, "&"),
+                _ => {}
             }
             write!(out, "{}", arg.ident);
             match arg.ty {
                 Type::RustBox(_) => write!(out, ".into_raw()"),
                 Type::UniquePtr(_) => write!(out, ".release()"),
+                Type::Str(_) => write!(out, ")"),
                 _ => {}
             }
         }
diff --git a/include/cxxbridge.h b/include/cxxbridge.h
index c8f85a9..a0c0b07 100644
--- a/include/cxxbridge.h
+++ b/include/cxxbridge.h
@@ -17,7 +17,7 @@ public:
   String &operator=(const String &other) noexcept;
   String &operator=(String &&other) noexcept;
   ~String() noexcept;
-  operator std::string() const;
+  explicit operator std::string() const;
 
   // Note: no null terminator.
   const char *data() const noexcept;
@@ -37,7 +37,7 @@ public:
   Str(std::string &&s) = delete;
   Str(const Str &other) noexcept;
   Str &operator=(Str other) noexcept;
-  operator std::string() const;
+  explicit operator std::string() const;
 
   // Note: no null terminator.
   const char *data() const noexcept;
@@ -53,7 +53,7 @@ public:
     size_t len;
   };
   Str(Repr repr) noexcept;
-  operator Repr() noexcept;
+  explicit operator Repr() noexcept;
 
 private:
   Repr repr;

